; aurora logo
; Copyright (C) 2002-2003 Michael Schalla
; Copyright (C) 2004-2008 Eric Lamarque

; This program is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2 of the License, or
; (at your option) any later version.
;
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with this program; if not, write to the Free Software
; Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

;  
; --------------------------------------------------------------------
; version 1.0 by Michael Schalla 2003/02/17
; version 2.0 by Eric Lamarque 2004/08/20
; version 2.4 by Eric Lamarque 2007/05/17
; version 2.4.1 by Eric Lamarque 2008/11/03 - License Fix + script register
; --------------------------------------------------------------------
;

(define (script-fu-aurora-logo inText inFont inFontSize inWhirl inWind1 inWind2 inBGColor inColor inAbsolute inImageWidth inImageHeight inFlatten)
  (let*
    (
      ; Definition unserer lokalen Variablen

      ; Erzeugen des neuen Bildes

      (img  ( car (gimp-image-new 10 10 RGB) ) )
      (theText)
      (theTextWidth)
      (theTextHeight)
      (imgWidth)
      (imgHeight)
      (imgWidthR)
      (imgHeightR)
      (theBufferX)
      (theBufferY)
	  (theLayer2)
	  (theLayer3)
	  (theLayer4)

      ; Erzeugen einer neuen Ebene zum Bild
      (theLayer (car (gimp-layer-new img 10 10 RGB-IMAGE "Layer 1" 100 NORMAL) ) )
      (old-fg (car (gimp-context-get-foreground) ) )
      (old-bg (car (gimp-context-get-background) ) )
      ; Ende unserer lokalen Variablen
    )

    (gimp-image-add-layer img theLayer 0)

    ; zum Anzeigen des leeren Bildes
    ; (gimp-display-new img)

    (gimp-context-set-background '(255 255 255) )
    (gimp-context-set-foreground '(0 0 0) )

    (gimp-selection-all  img)
    (gimp-edit-clear     theLayer)
    (gimp-selection-none img)

    (set! theText (car (gimp-text-fontname img theLayer 0 0 inText 0 TRUE inFontSize PIXELS inFont)))

    (set! theTextWidth  (car (gimp-drawable-width  theText) ) )
    (set! theTextHeight (car (gimp-drawable-height theText) ) )

    (set! imgWidth (max (+ theTextWidth (* theTextHeight 2 ) (* (+ inWind2 (/ 100 (+ inWind1 1) ) ) 2.5) ) inImageWidth inImageHeight ) )
    (set! imgHeight imgWidth )

    (set! theBufferX      (/ (- imgWidth theTextWidth) 2) )
    (set! theBufferY      (/ (- imgHeight theTextHeight) 2) )

    (gimp-image-resize img imgWidth imgHeight 0 0)
    (gimp-layer-resize theLayer imgWidth imgHeight 0 0)

    (gimp-layer-set-offsets   theText theBufferX theBufferY)
    (gimp-floating-sel-anchor theText)

    (set! theLayer2 (car (gimp-layer-copy theLayer TRUE)))
    (gimp-image-add-layer img theLayer2 0)

    (plug-in-whirl-pinch 1 img theLayer2 inWhirl 0.0 1.0)

    (set! theLayer3 (car (gimp-layer-copy theLayer2 TRUE)))
    (gimp-image-add-layer img theLayer3 0)

    (plug-in-wind 1 img theLayer2 inWind1 1 inWind2 0 0)
    (plug-in-wind 1 img theLayer3 inWind1 0 inWind2 0 0)

    (gimp-layer-set-mode theLayer3 DARKEN-ONLY)
		
		(set! theLayer4 (car (gimp-image-merge-down img theLayer3 0)))

    (plug-in-whirl-pinch 1 img theLayer4 (- 0 inWhirl) 0.0 1.0)
    (plug-in-gauss-iir 1 img theLayer4 3 TRUE TRUE)
    (plug-in-autostretch-hsv 0 img theLayer4)
    
    (plug-in-color-map 1 img theLayer4 '(128 128 128) '(255 255 255) inColor inBGColor 0)
    (gimp-invert theLayer4)

    (gimp-layer-set-mode theLayer4 DIFFERENCE)

    (plug-in-gauss-iir 1 img theLayer 1 TRUE TRUE)

    (set! imgWidthR inImageWidth )
    (set! imgHeightR inImageHeight )

  	(if (= inAbsolute FALSE)
      (set! imgWidthR (+ theTextWidth (* theTextHeight 2 ) (* (+ inWind2 (/ 100 (+ inWind1 1) ) ) 2.5) ) )
    )

  	(if (= inAbsolute FALSE)
      (set! imgHeightR ( + (* theTextHeight 3 ) (* (+ inWind2 (/ 100 (+ inWind1 1) ) ) 2.5) ) )
    )

    (set! theBufferX      (/ (- imgWidthR imgWidth) 2) )
    (set! theBufferY      (/ (- imgHeightR imgHeight) 2) )

    (gimp-image-resize img imgWidthR imgHeightR theBufferX theBufferY)

  	(if (= inFlatten TRUE)
      (gimp-image-flatten img)
  	)
	
    (gimp-context-set-background old-bg)
    (gimp-context-set-foreground old-fg)

    (gimp-display-new     img)
    (list  img theLayer theText)

    ; Bereinigen Dirty-Flag
    (gimp-image-clean-all img)

  )
)

(script-fu-register
  "script-fu-aurora-logo"
  "Aurora Borealis..."
  "Creates a text logo."
  "Michael Schalla"
  "Michael Schalla"
  "October 2002"
  ""
  SF-STRING "Tekst"             "Aurora Borealis"
  SF-FONT   "Czcionka"             "-*-Arial Black-*-r-*-*-24-*-*-*-p-*-*-*"
  SF-VALUE  "Rozmiar czcionki"        "50"
  SF-VALUE  "Wielkość zawirowania"     "90"
  SF-ADJUSTMENT "Wiatr1"        '(10 0 50 1 1 0 1)
  SF-ADJUSTMENT "Wiatr2"        '(10 1 50 1 1 0 1)
  SF-COLOR "Kolor tła"          '(0 0 0)
  SF-COLOR "Kolor"             '(64 128 192)
  SF-TOGGLE "Rozmiar bezwzględny?"   FALSE
  SF-VALUE  "Szerokość obrazu"      "300"
  SF-VALUE  "Wysokość obrazu"     "100"
  SF-TOGGLE "Połączyć warstwy?"  FALSE
)

(script-fu-menu-register "script-fu-aurora-logo"
			 "<Image>/File/Create/Logos")
