; Fiery Beveled Text
; Script-Fu for GIMP 2.6 , by LightningIsMyName
; 
; This script makes a beveled text logo with flames
; 
; This script was written by LightningIsMyName
; Email: lightningismyname(at)gmail(dot)com 
; My Home Page: http://lightningismyname.deviantart.com/
;
; This Program is a free software, and you may use it for any purpose, comercial and non-commercial.
; You may not sell or redistribute this software alone or inside a bundle unless it's for FREE.
; You may modify this script only if:
; 1. You keep this message with my email, homepage, description, and release log.
; 2. You share alike with the same licensing, and without any profit.
;
; This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without
; even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
; 
; Release Log: Version 1.0 - December 2007
;              Initial public release, for GIMP 2.4
;
;              Version 1.1 - February 2009
;              Another public release, for GIMP 2.6.
;              Updated the let* syntax so it will also work on GIMP 2.6
;              Updated the menu registration of the script


(define (script-fu-logos-beveledfire string font size color gradient merge)
  
  (let*
      (
       
       (img (car
             (gimp-image-new 1 1 RGB)))
       
       (text (car 
              (gimp-text-fontname img -1 0 0 string 0 TRUE size 0 font)))
       
       (width (car 
               (gimp-drawable-width text)))
       
       (height (car 
                (gimp-drawable-height text)))
       
       (pattern 0)
       
       (hardlight 0)
       
       (displace 0)
       
       (colorify 0)
       
       (fire 0)
       
       (paste 0)
       
       )
    
    (set! width (+ 50 width))
    
    (set! height (+ 50 height))
    
    (gimp-image-resize img width height 25 25)
    
    (gimp-display-new img)
    
    (gimp-layer-resize-to-image-size text)
    
    (gimp-selection-layer-alpha text)
    
    (gimp-context-set-gradient "Incandescent")
    
    (gimp-edit-blend text 3 0 7 100 0 0 TRUE FALSE 1 0 TRUE 0 0 1 1)
    
    (gimp-selection-none img)
    
    (plug-in-neon 1 img text 5 0)
    
    (gimp-context-set-gradient "Flare Sizefac 101")
    
    (plug-in-gradmap 1 img text)
    
    (set! colorify (car(gimp-layer-new-from-drawable text img)))
    
    (gimp-image-add-layer img colorify -1)
    
    (plug-in-colorify 1 img colorify color)
    
    (gimp-layer-set-mode colorify 19)
    
    (gimp-selection-layer-alpha colorify)
    
    (set! pattern (car(gimp-layer-new img width height RGB "Pattern" 100 21)))
    
    (gimp-image-add-layer img pattern -1)
    
    (gimp-selection-none img)
    
    (gimp-layer-add-alpha pattern)
    
    (gimp-edit-clear pattern)
    
    (gimp-patterns-set-pattern "Amethyst")
    
    (gimp-selection-layer-alpha colorify)
    
    (gimp-edit-bucket-fill pattern 2 0 100 255 FALSE 0 0)
    
    (plug-in-gauss 1 img pattern 6 6 0)
    
    (gimp-selection-none img)
    
    (gimp-edit-copy-visible img)
    
    (set! hardlight(car(gimp-layer-new img width height RGB "HardLight" 100 18)))
    
    (gimp-image-add-layer img hardlight -1)
    
    (gimp-layer-add-alpha hardlight)
    
    (gimp-edit-clear hardlight)
    
    (set! paste (car(gimp-edit-paste hardlight TRUE)))
    
    (gimp-floating-sel-anchor paste)
    
    (gimp-context-set-gradient gradient)
    
    (plug-in-gradmap 1 img hardlight)
    
    (set! displace (car(gimp-layer-new img width height RGB "Displace" 100 0)))
    
    (gimp-image-add-layer img displace -1)
    
    (gimp-patterns-set-pattern "Amethyst")
    
    (gimp-selection-all img)
    
    (gimp-edit-bucket-fill displace 2 0 100 255 FALSE 0 0)
    
    (plug-in-gauss 1 img displace 6 6 0)
    
    (gimp-drawable-set-visible displace FALSE)
    
    (gimp-edit-copy-visible img)
    
    (set! fire(car(gimp-layer-new img width height RGB "FIRE" 100 18)))
    
    (gimp-image-add-layer img fire 5)
    
    (gimp-layer-add-alpha fire)
    
    (gimp-edit-clear fire)
    
    (set! paste (car(gimp-edit-paste fire TRUE)))
    
    (gimp-floating-sel-anchor paste)
    
    (plug-in-warp 1 img fire 20 displace 10 0 90 1 displace FALSE 1 displace 0 displace 0 0)
    
    (gimp-image-remove-layer img displace)
    
    (gimp-curves-spline fire 4 8 #(0 0 101 59 137 197 255 255))	;making flames more solid
    
    (if (= merge 1)
        (gimp-image-merge-visible-layers img 1) )
    
    (gimp-displays-flush)
    
    )
  )


(script-fu-register
 "script-fu-logos-beveledfire"
 "<Image>/File/Create/Logos/Beveled Flaming Text..."
 "Make a beveled fiery logo"
 "LightningIsMyName (LIMN)"
 "LightningIsMyName (LIMN)"
 "December 2007"
 ""
 
 SF-STRING	"Tekst:"         								"I'm On Fire!"
 SF-FONT		"Czcionka (różne rodzaje czcionek dają różne fazowanie)"    			"Serif Bold Italic"
 SF-ADJUSTMENT	"Rozmiar czcionki (px) (lepsze wyniki z dużym tekstem)"	'(100 1 1000 1 10 0 1)
 SF-COLOR	"Kolor podstawy:"        								'(255 0 0)
 SF-GRADIENT	"Gradient (wybierz pasujący do koloru)"				"German flag smooth"
 SF-TOGGLE 	"Połącz warstwy" FALSE
 
 )

