(define (script-fu-BindingLogo text
			       size
			       font
			       bind-color
			       base-color
	)

  (let* (
	  (img (car (gimp-image-new 256 256 RGB)))
          (border (/ size 4))
	  (bind-layer 0)
	  (base-layer 0)
	  (back-layer 0)
	  (shadow-layer 0)
	  (width 0)
	  (height 0)
	  (oldfg 0)
	  (oldbg 0)
	  (shadow '(100 100 100))
        )

	(set! oldfg (car (gimp-palette-get-foreground)))
	(set! oldbg (car (gimp-palette-get-background)))
	(gimp-palette-set-foreground bind-color)
	(gimp-palette-set-background base-color)
	(set! base-layer (car (gimp-text-fontname img -1 0 0 text border TRUE size 0 font)))
	(set! bind-layer (car (gimp-layer-copy base-layer 1)))
	(set! width (car (gimp-drawable-width base-layer)))
	(set! height (car (gimp-drawable-height base-layer)))
	(set! back-layer (car (gimp-layer-new img width height RGBA-IMAGE "Background" 100 NORMAL)))

	(gimp-image-resize img width height 0 0)

	(gimp-selection-layer-alpha base-layer)
	(gimp-edit-fill base-layer BG-IMAGE-FILL)
	(gimp-selection-none img)

	(gimp-layer-set-name base-layer "BaseText")
	(gimp-layer-set-name bind-layer "BindText")
	(gimp-image-add-layer img bind-layer -1)
	(gimp-image-add-layer img back-layer 2)

	(gimp-selection-all img)
	(gimp-drawable-fill back-layer 2)
	(gimp-selection-none img)

	(gimp-layer-set-offsets bind-layer 2 0)
	(gimp-drawable-transform-shear bind-layer 0 -60 0 1 0 3 0)
	(gimp-layer-set-mode bind-layer SCREEN)

	(set! shadow-layer (car (gimp-layer-copy base-layer 1)))
	(gimp-image-add-layer img shadow-layer 2)
	(gimp-layer-set-name shadow-layer "Shadow")
	(gimp-selection-layer-alpha shadow-layer)
	(gimp-palette-set-foreground shadow)
	(gimp-edit-fill shadow-layer 0)
	(gimp-selection-all img)
	(plug-in-gauss-iir2 1 img shadow-layer 5 5)
	(gimp-selection-none img)
	(gimp-layer-set-offsets shadow-layer 5 5)

	(gimp-layer-resize-to-image-size bind-layer)
	(gimp-layer-set-name base-layer "LogoText")
	(gimp-image-merge-down img bind-layer 0)

	(gimp-palette-set-foreground oldfg)
	(gimp-palette-set-background oldbg)
	(gimp-display-new img)
  )

)

(script-fu-register "script-fu-BindingLogo"
		    "Binding..."
		    "Binding Logo"
		    "yotsuba."
		    "Copyright 2005, product by yotsuba."
		    "2005"
		    ""
		    SF-STRING _"Tekst" "Bind or Crossing ?"
		    SF-ADJUSTMENT _"Rozmiar czcionki (px)"     '(100 2 1000 1 10 0 1)
		    SF-FONT   _"Czcionka" "Arial"
		    SF-COLOR  _"Kolor-1"  '(143 143 143)
		    SF-COLOR  _"Kolor-2"  '(153 206 255)
)

(script-fu-menu-register "script-fu-BindingLogo"
		    "<Image>/File/Create/Logos"
)
